<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-row>
        <el-col :span="24">
          <el-form-item label="试题：" prop="cqoQuestId">
            <!-- 替换为模拟输入框样式的 div 容器 -->
            <div v-html="queryParams.cqoQuestion">
            </div>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="选项内容" prop="cqoOption">
        <el-input
          v-model="queryParams.cqoOption"
          placeholder="请输入选项内容"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="选项分值" prop="cqoSocre">
        <el-input
          v-model="queryParams.cqoSocre"
          placeholder="请输入选项分值"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="答案" prop="cqoIsAnswer">
        <el-select
          v-model="queryParams.cqoIsAnswer"
          placeholder="请选择答案"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          v-if="tenantId == getTenantId()"
          @click="openForm('create', null, queryParams.cqoQuestId)"
          v-hasPermi="['bjdx:course-quest-option:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['bjdx:course-quest-option:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
<!--      <el-table-column label="课程试题选项id" align="center" prop="id" />-->
<!--      <el-table-column label="试题id" align="center" prop="cqoQuestId" />-->
      <el-table-column label="选项" align="center" prop="cqoValue" />
      <el-table-column label="选项内容" align="center" prop="cqoOption" >
        <template #default="scope">
          <div v-html="scope.row.cqoOption"></div>
        </template>
      </el-table-column>
      <el-table-column label="选项分值" align="center" prop="cqoSocre" />
      <el-table-column label="答案" align="center" prop="cqoIsAnswer">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.INFRA_BOOLEAN_STRING" :value="scope.row.cqoIsAnswer" />
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" min-width="120px">
        <template #default="scope">
          <el-button
            link
            type="primary"
            v-if="scope.row.tenantId == getTenantId()"
            @click="openForm('update', scope.row.id, queryParams.cqoQuestId)"
            v-hasPermi="['bjdx:course-quest-option:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            v-if="scope.row.tenantId == getTenantId()"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['bjdx:course-quest-option:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <CourseQuestOptionForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import download from '@/utils/download'
import { CourseQuestOptionApi, CourseQuestOptionVO } from '@/api/bjdx/coursequestoption'
import CourseQuestOptionForm from './CourseQuestOptionForm.vue'
import { useRoute } from 'vue-router'
import { getTenantId } from '@/utils/auth'
import { ElButton } from 'element-plus'

/** 课程-试题-选项 列表 */
defineOptions({ name: 'CourseQuestOption' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<CourseQuestOptionVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  cqoQuestId: undefined,
  cqoQuestion: undefined,
  cqoValue: undefined,
  cqoOption: undefined,
  cqoSocre: undefined,
  cqoIsAnswer: undefined
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中
const route = useRoute()
const tenantId = ref(undefined)

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {

    queryParams.cqoQuestId = route.query.questId
    queryParams.cqoQuestion = route.query.question
    tenantId.value = route.query.tenantId

    const data = await CourseQuestOptionApi.getCourseQuestOptionPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number, questId?: number) => {
  formRef.value.open(type, id, questId)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await CourseQuestOptionApi.deleteCourseQuestOption(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await CourseQuestOptionApi.exportCourseQuestOption(queryParams)
    download.excel(data, '课程-试题-选项.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
